const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Compliance_auditsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const compliance_audits = await db.compliance_audits.create(
      {
        id: data.id || undefined,

        date: data.date || null,
        result: data.result || null,
        issues_found: data.issues_found || null,
        report_url: data.report_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await compliance_audits.setOrganization(
      currentUser.organization.id || null,
      {
        transaction,
      },
    );

    await compliance_audits.setOwner(data.owner || null, {
      transaction,
    });

    await compliance_audits.setOrganizations(data.organizations || null, {
      transaction,
    });

    return compliance_audits;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const compliance_auditsData = data.map((item, index) => ({
      id: item.id || undefined,

      date: item.date || null,
      result: item.result || null,
      issues_found: item.issues_found || null,
      report_url: item.report_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const compliance_audits = await db.compliance_audits.bulkCreate(
      compliance_auditsData,
      { transaction },
    );

    // For each item created, replace relation files

    return compliance_audits;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const compliance_audits = await db.compliance_audits.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.date !== undefined) updatePayload.date = data.date;

    if (data.result !== undefined) updatePayload.result = data.result;

    if (data.issues_found !== undefined)
      updatePayload.issues_found = data.issues_found;

    if (data.report_url !== undefined)
      updatePayload.report_url = data.report_url;

    updatePayload.updatedById = currentUser.id;

    await compliance_audits.update(updatePayload, { transaction });

    if (data.organization !== undefined) {
      await compliance_audits.setOrganization(
        globalAccess ? data.organization : currentUser.organization.id,
        { transaction },
      );
    }

    if (data.owner !== undefined) {
      await compliance_audits.setOwner(
        data.owner,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await compliance_audits.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return compliance_audits;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const compliance_audits = await db.compliance_audits.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of compliance_audits) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of compliance_audits) {
        await record.destroy({ transaction });
      }
    });

    return compliance_audits;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const compliance_audits = await db.compliance_audits.findByPk(id, options);

    await compliance_audits.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await compliance_audits.destroy({
      transaction,
    });

    return compliance_audits;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const compliance_audits = await db.compliance_audits.findOne(
      { where },
      { transaction },
    );

    if (!compliance_audits) {
      return compliance_audits;
    }

    const output = compliance_audits.get({ plain: true });

    output.organization = await compliance_audits.getOrganization({
      transaction,
    });

    output.owner = await compliance_audits.getOwner({
      transaction,
    });

    output.organizations = await compliance_audits.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.organizations,
        as: 'organization',
      },

      {
        model: db.users,
        as: 'owner',

        where: filter.owner
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.owner
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  firstName: {
                    [Op.or]: filter.owner
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.report_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'compliance_audits',
            'report_url',
            filter.report_url,
          ),
        };
      }

      if (filter.dateRange) {
        const [start, end] = filter.dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.issues_foundRange) {
        const [start, end] = filter.issues_foundRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            issues_found: {
              ...where.issues_found,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            issues_found: {
              ...where.issues_found,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.result) {
        where = {
          ...where,
          result: filter.result,
        };
      }

      if (filter.organization) {
        const listItems = filter.organization.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationId: { [Op.or]: listItems },
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.compliance_audits.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('compliance_audits', 'date', query),
        ],
      };
    }

    const records = await db.compliance_audits.findAll({
      attributes: ['id', 'date'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['date', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.date,
    }));
  }
};
